/* 
  project "Evaluations-Platine für Heimautomatisierung"
  created 2013 by Thomas Gauweiler
  copyright: Apache License 2.0, http://www.apache.org/licenses/LICENSE-2.0.html
*/
#define SKETCH_NAME "BUTTONS"
#define PIN_BUTTONS A5

#define BUTTON_1    184
#define BUTTON_2    252
#define BUTTON_3    328
#define BUTTON_12   118
#define BUTTON_13   132
#define BUTTON_23   165
#define BUTTON_123   94
#define NOBUTTON   1023

void setup_serial() {
  Serial.begin(9600);
  Serial.print(SKETCH_NAME);
  Serial.println(" is ready");
}

void setup() {
  setup_serial();
}


/******************************************/

bool is_nearly(const int requirement, const int value) {
  return (requirement - 10 < value && value < requirement + 10);
}

bool is_only_button1(const int value) {
  return (is_nearly(BUTTON_1, value));
}

bool is_only_button2(const int value) {
  return (is_nearly(BUTTON_2, value));
}

bool is_only_button3(const int value) {
  return (is_nearly(BUTTON_3, value));
}

bool is_button12(const int value) {
  return (is_nearly(BUTTON_12, value));
}

bool is_button13(const int value) {
  return (is_nearly(BUTTON_13, value));
}

bool is_button23(const int value) {
  return (is_nearly(BUTTON_23, value));
}

bool is_button123(const int value) {
  return (is_nearly(BUTTON_123, value));
}

bool is_button1(const int value) {
  return (is_only_button1(value) || is_button12(value) || is_button13(value) || is_button123(value));
}

bool is_button2(const int value) {
  return (is_only_button2(value) || is_button12(value) || is_button23(value) || is_button123(value));
}

bool is_button3(const int value) {
  return (is_only_button3(value) || is_button13(value) || is_button23(value) || is_button123(value));
}

void loop()
{
  int buttonsValue = 0;
  buttonsValue = analogRead(PIN_BUTTONS);
  Serial.print(" B1: ");   Serial.print(is_button1(buttonsValue));
  Serial.print(" B2: ");   Serial.print(is_button2(buttonsValue));
  Serial.print(" B3: ");   Serial.print(is_button3(buttonsValue));
  Serial.print(" - ");     Serial.println(buttonsValue);
  delay (800);
}

